<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>CSDIDAC Middleware Library</title>
    <detaileddescription>
<para>The CSDIDAC middleware is the IDAC solution that uses the CSD HW block. Any GPIO that can be connected to AMUX-A/B (refer to the particular device datasheet for information) can be an CSDIDAC output under software control. The CSD HW block is mainly used to implement the touch sense applications and proximity sensors (refer to the <ulink url="https://cypresssemiconductorco.github.io/capsense/capsense_api_reference_manual/html/index.html">CapSense Middleware API Reference Guide</ulink>), but can also be used to implement the IDAC, which is especially useful for the devices that do not include another hardware option to implement IDAC.</para><para><bold>Features:</bold><itemizedlist>
<listitem><para>A two-channel IDAC with the 7-bit resolution.</para></listitem><listitem><para>The IDAC A and IDAC B channels can be enabled/disabled independently.</para></listitem><listitem><para>The IDAC A and IDAC B channels can be configured with sourcing/sinking current independently.</para></listitem><listitem><para>The IDAC A and IDAC B channels can be joined to increase a maximum output current.</para></listitem><listitem><para>The IDAC A and IDAC B channels can be enabled/disabled simultaneously by using the CY_CSDIDAC_AB option.</para></listitem><listitem><para>The 0 to 609.6 uA (609600 nA) current range is available for each IDAC channel.</para></listitem><listitem><para>Each IDAC can use independently one of the six available LSB depending on a desired output current:</para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;LSB Index&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;LSB&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Available Current Range &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;37.5 nA &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0 to 4762.5 nA  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;75.0 nA &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0 to 9525.0 nA  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0.3 uA &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0 to 38.1 uA  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0.6 uA &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0 to 76.2 uA  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.4 uA &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0 to 304.8 uA  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;5 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;4.8 uA &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0 to 609.6 uA  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
<para><heading level="1">General Description</heading></para>
<para>Include cy_csdidac.h to get access to all functions and other declarations in this library. The <ref kindref="member" refid="index_1section_csdidac_quick_start">Quick Start Guide</ref> is offered in this API Reference Guide.</para><para>Refer to the <ref kindref="member" refid="index_1section_csdidac_toolchain">Supported Software and Tools</ref> for the compatibility information.</para><para>Refer to the <ref kindref="member" refid="index_1group_csdidac_changelog">Changelog</ref> for the differences between the middleware versions. <ref kindref="member" refid="index_1group_csdidac_changelog">Changelog</ref> also describes the impact of changes to your code.</para><para>The CSD HW block enables the multiple sensing capabilities on PSoC devices including the self-cap and mutual-cap capacitive touch sensing solution, 10-bit ADC, IDAC, and Comparator. The CSD driver is a low-level peripheral driver, a wrapper to manage access to the CSD HW block. Any middleware access to the CSD HW block is through the CSD Driver.</para><para>The CSD HW block can support only one function at a time. However, all supported functionality (like CapSense, CSDADC, CSDIDAC, etc.) can be time-multiplexed in a design. I.e. you can save the existing state of the CapSense middleware, restore the state of the CSDIDAC middleware, perform DAC operations, and then switch back to the CapSense functionality. For more details and code examples, refer to the description of the <ref kindref="member" refid="group__group__csdidac__functions_1ga9533392a382045b3d9817569fbcd84d2">Cy_CSDIDAC_Save()</ref> and <ref kindref="member" refid="group__group__csdidac__functions_1gaf69c7fa3ab468bee95ecc92cc596f3ab">Cy_CSDIDAC_Restore()</ref> functions.</para><para><image name="capsense_solution.png" type="html" width="800px">CapSense Solution</image>
 
</para><para>This section describes only the CSDIDAC middleware. Refer to the corresponding sections for documentation of other middleware supported by the CSD HW block. The CSDIDAC library is designed to be used with the CSD driver. The application program does not need to interact with the CSD driver and/or other drivers such as GPIO or SysClk directly. All of that is configured and managed by the middleware.</para><para>The Cy_CSDIDAC API is described in the following sections:<itemizedlist>
<listitem><para><ref kindref="compound" refid="group__group__csdidac__macros">Macros</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__csdidac__data__structures">Data Structures</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__csdidac__enums">Enumerated types</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__csdidac__functions">Functions</ref></para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick Start Guide</heading></para>
<para>The CSDIDAC middleware can be used in various Development Environments such as ModusToolbox, MBED, etc. Refer to the <ref kindref="member" refid="index_1section_csdidac_toolchain">Supported Software and Tools</ref>. The quickest way to get started is using the Code Examples. The continually expanding portfolio of the code examples is available at the <ulink url="http://www.cypress.com">Cypress Semiconductor website</ulink> and on <ulink url="https://github.com/cypresssemiconductorco">GitHub</ulink>.</para><para>This quick start guide assumes that the environment is configured to use the PSoC 6 Peripheral Driver Library(psoc6pdl) for development and the PSoC 6 Peripheral Driver Library(psoc6pdl) is included in the project.</para><para>The steps required to set up the CSDIDAC and get the desired current:</para><para><orderedlist>
<listitem><para>Set up the CSDIDAC configuration manually or by using the Device Configurator as described in the <ref kindref="member" refid="index_1section_csdidac_configuration">Configuration Considerations</ref> section. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Put the CSDIDAC name to the Alias field of the CSD resource if the Device Configurator is used.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para></listitem><listitem><para>Include cy_csdidac.h to get access to all CSDIDAC API and cy_pdl.h to get access to API of peripheral drivers according to the example below: <programlisting><codeline><highlight class="preprocessor">#include<sp />"cy_pdl.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_csdidac.h"</highlight><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>If you use the MBED OS, include the cycfg.h file to get access to the System Configuration: <programlisting><codeline><highlight class="preprocessor">#include<sp />"cycfg.h"</highlight><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>Declare the 'cy_csdidac_context' variable as per example below: <programlisting><codeline><highlight class="comment">/*<sp />CSDIDAC<sp />context<sp />declaration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__csdidac__context__t">cy_stc_csdidac_context_t</ref><sp />csdidac_context;</highlight></codeline>
</programlisting></para></listitem><listitem><para>Update the main() routine with the following code: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />UNCOMMENT<sp />THIS<sp />CODE<sp />if<sp />you<sp />use<sp />the<sp />MBED<sp />OS:<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//init_cycfg_clocks();</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//init_cycfg_routing();</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//init_cycfg_peripherals();</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />UNCOMMENT<sp />THIS<sp />CODE<sp />if<sp />you<sp />implement<sp />the<sp />initialization<sp />code<sp />manually</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />to<sp />assign<sp />the<sp />Peripheral<sp />Clock<sp />Divider<sp />to<sp />the<sp />CSD<sp />HW<sp />block</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />and<sp />to<sp />configure<sp />the<sp />divider<sp />value.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#if<sp />defined(CY_IP_MXCSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />Cy_SysClk_PeriphDisableDivider(CY_SYSCLK_DIV_8_BIT,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />Cy_SysClk_PeriphAssignDivider(PCLK_CSD_CLOCK,<sp />CY_SYSCLK_DIV_8_BIT,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />Cy_SysClk_PeriphSetDivider(CY_SYSCLK_DIV_8_BIT,<sp />0u,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />Cy_SysClk_PeriphEnableDivider(CY_SYSCLK_DIV_8_BIT,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#elif<sp />defined(CY_IP_M0S8CSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />Cy_SysClk_PeriphDisableDivider(CY_SYSCLK_DIV_16_BIT,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />Cy_SysClk_PeriphAssignDivider(PCLK_CSD_CLOCK,<sp />CY_SYSCLK_DIV_16_BIT,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />Cy_SysClk_PeriphSetDivider(CY_SYSCLK_DIV_16_BIT,<sp />0u,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />Cy_SysClk_PeriphEnableDivider(CY_SYSCLK_DIV_16_BIT,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />#error<sp />Not<sp />supported<sp />device</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#endif<sp />/*<sp />CY_IP_MXCSDV2<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />UNCOMMENT<sp />THIS<sp />CODE<sp />if<sp />you<sp />implement<sp />the<sp />initialization<sp />code<sp />manually<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />set<sp />configuration<sp />of<sp />the<sp />HSIOM_AMUX_SPLIT_CTL<sp />switches.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />The<sp />AMUX<sp />bus<sp />has<sp />segments<sp />that<sp />are<sp />separated<sp />with<sp />the<sp />HSIOM_AMUX_SPLIT_CTL<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />switches.<sp />The<sp />code<sp />below<sp />closes<sp />the<sp />AMUX_SPLIT_CTL<sp />switches,<sp />which<sp />route</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />the<sp />IDAC<sp />output<sp />signal<sp />from<sp />the<sp />CSD<sp />block<sp />to<sp />the<sp />pin.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />In<sp />this<sp />example,<sp />IDAC<sp />output<sp />channels<sp />are<sp />assigned<sp />to<sp />the<sp />P0[4]<sp />and<sp />P[5]<sp />pins.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />The<sp />AMUX_SPLIT_CTL[5]<sp />and<sp />AMUX_SPLIT_CTL[6]<sp />switches<sp />must<sp />be<sp />closed<sp />in<sp />the</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />PSoC6<sp />device.<sp />The<sp />P0[4]<sp />and<sp />P[5]<sp />pins<sp />in<sp />the<sp />PSoC4<sp />device<sp />belong<sp />to<sp />the</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />AMUX<sp />bus<sp />segment,<sp />which<sp />is<sp />connected<sp />to<sp />the<sp />CSD<sp />block<sp />directly.<sp />In<sp />this<sp />case,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />the<sp />AMUX_SPLIT_CTL<sp />switches<sp />are<sp />not<sp />closed.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#if<sp />defined(CY_IP_MXCSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#if(1u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[5]<sp />=<sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_AA_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_AA_SR_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[6]<sp />=<sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_AA_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_AA_SR_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#elif(2u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[5]<sp />=<sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_AA_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_AA_SR_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[6]<sp />=<sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_AA_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_AA_SR_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp />#error<sp />Not<sp />supported<sp />device</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Captures<sp />the<sp />CSD<sp />HW<sp />block<sp />and<sp />initializes<sp />it<sp />to<sp />the<sp />default<sp />state.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csdidac__functions_1ga2306e26e53cbc25c6dff0fd76bf39d49">Cy_CSDIDAC_Init</ref>(&amp;CSDIDAC_csdidac_config,<sp />&amp;csdidac_context);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Generates<sp />a<sp />sourcing<sp />current<sp />of<sp />50<sp />uA<sp />(50000<sp />nA)<sp />on<sp />the<sp />IDAC<sp />A<sp />output.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csdidac__functions_1gab98734d77671b95d22aed6976c843afe">Cy_CSDIDAC_OutputEnable</ref>(<ref kindref="member" refid="group__group__csdidac__enums_1gga50d76718e6bca3ac87f455c074cbbc10afd995410b7ce2229624433f60708969c">CY_CSDIDAC_A</ref>,<sp />50000,<sp />&amp;csdidac_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Generates<sp />a<sp />sinking<sp />current<sp />of<sp />0.5uA<sp />(-500<sp />nA)<sp />on<sp />the<sp />IDAC<sp />B<sp />output.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csdidac__functions_1gab98734d77671b95d22aed6976c843afe">Cy_CSDIDAC_OutputEnable</ref>(<ref kindref="member" refid="group__group__csdidac__enums_1gga50d76718e6bca3ac87f455c074cbbc10a708c231fc2cdb553d777ea0108b44465">CY_CSDIDAC_B</ref>,<sp />-500,<sp />&amp;csdidac_context);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para></listitem></orderedlist>
</para>

<para><heading level="1">Configuration Considerations</heading></para>
<para>The CSDIDAC middleware operates on the top of the CSD Driver included in the PSoC 6 Peripheral Driver Library (psoc6pdl). Refer to the "CSD(CapSense
Sigma Delta)" section of the PSoC 6 Peripheral Driver Library (psoc6pdl) API Reference Manual. This section guides how to set up the CSDIDAC middleware for the operation with the following parameters:<orderedlist>
<listitem><para>Device VDDA: 3.3V.</para></listitem><listitem><para>Device Peri Clock frequency: 48MHz.</para></listitem><listitem><para>IDAC A is sourcing current of 50 uA to GPIO pin P0[4].</para></listitem><listitem><para>IDAC B is sinking current of 0.5uA from GPIO pin P0[5].</para></listitem></orderedlist>
</para><para>There are two methods for the CSDIDAC Middleware configuration:<orderedlist>
<listitem><para><ref kindref="member" refid="index_1subsection_csdidac_mtb_configuring">Use ModusToolbox Device Configurator Tool to generate initialization code</ref></para></listitem><listitem><para><ref kindref="member" refid="index_1subsection_csdidac_manual_configuring">Implement the initialization code manually</ref></para></listitem></orderedlist>
</para><para>Generation of the initialization code using the <ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool </ulink> which is part of the <ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox</ulink>, greatly simplifies the PSoC configuration. The <ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool </ulink> provides the user interface to set up and automatically generate the initialization code (including analog routing) and configuration structures.</para><para>Manual implementation of the initialization code (including analog routing) and configuration structures is recommended for expert Users only. This will include the code for the following settings which in case of the Device Configurator usage are generated automatically based upon the settings entered in its UI:<itemizedlist>
<listitem><para>Assigning the Peripheral Clock Divider.</para></listitem><listitem><para>Configuring the HSIOM_AMUX_SPLIT_CTL switches to route signal from input pins configured as the CSDIDAC channels to the CSD HW block.</para></listitem><listitem><para>Declaration and initialization of the CSDIDAC configuration structure.</para></listitem><listitem><para>Declaration and initialization of the CSD HW driver context structure.</para></listitem><listitem><para>Definition of the of the CSD HW block base address.</para></listitem></itemizedlist>
</para>
<para><bold>Use ModusToolbox Device Configurator Tool to generate initialization code</bold></para>
<para>The steps required to generate the initialization code using the <ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool </ulink>:<orderedlist>
<listitem><para>Launch the ModusToolbox Middleware Selector and enable the CSD IDAC middleware. This step is required only if the ModusToolbox IDE is used. Otherwise, ensure the CSDIDAC Middleware is included in your project.</para></listitem><listitem><para>Launch the ModusToolbox Device Configurator Tool.</para></listitem><listitem><para>Switch to the System tab. Configure the CLK_PERI frequency to achieve 48MHz (you may need to change the FLL or PLL frequency) and set the VDDA voltage to 3.3V in Power/MCU Personality.</para></listitem><listitem><para>Switch to the Peripherals tab (#1 in the figure below). Enable the CSD personality under System (#2 in the figure below) and enter Alias (#3 in the figure below). We use CSDIDAC in <ref kindref="member" refid="index_1section_csdidac_quick_start">Quick Start Guide</ref>.</para></listitem><listitem><para>Go to the Parameters pane and configure the CSD Personality:<itemizedlist>
<listitem><para>Assign the peripheral clock divider by using the Clock combo box(#4 in the figure below). Any free divider can be used.</para></listitem><listitem><para>Set the Enable CSDIDAC check box (#5 in the figure below).</para></listitem><listitem><para>Configure the CSDIDAC with the desired parameters per <ref kindref="member" refid="index_1section_csdidac_configuration">Configuration Considerations</ref> (#5 in the figure below).</para></listitem><listitem><para>Assign the CSDIDAC Channels to pins per <ref kindref="member" refid="index_1section_csdidac_configuration">Configuration Considerations</ref> (#6 in the figure below).</para></listitem></itemizedlist>
</para></listitem><listitem><para>Switch to the Peripheral Clocks tab and configure the assigned peripheral clock divider. The Max supported clock frequency for the CSD HW block is 50 MHz. The divider value "1" can be used, because in the current case the Peri Clock frequency is 48 MHz.</para></listitem><listitem><para>Perform File-&gt;Save to generate the initialization code.</para></listitem></orderedlist>
</para><para><image name="csdidac_config.png" type="html" width="1172px">CSDIDAC configuration</image>
 
</para><para>Now, all required CSDIDAC initialization code and configuration prerequisites will be generated:<itemizedlist>
<listitem><para>The Peripheral Clock Divider assignment and analog routing are parts of the init_cycfg_all() routine. Place the call of the init_cycfg_all() function before using any CSDIDAC API functions to ensure initialization of all external resources required for the CSDIDAC operation. Refer to the main() routine code snippet in <ref kindref="member" refid="index_1section_csdidac_quick_start">Quick Start Guide</ref></para></listitem><listitem><para>The CSDIDAC configuration structure declaration in the cycfg_peripherals.h file and its initialization in the cycfg_peripherals.c file. The variable name is &lt;Alias_Name&gt;_csdidac_config.</para></listitem><listitem><para>The CSD HW driver context structure declaration in the cycfg_peripherals.h file and its initialization in the cycfg_peripherals.c file. The variable name is cy_csd_&lt;CSD_Block_Index&gt;_context.</para></listitem><listitem><para>The CSD HW block base address definition is in the cycfg_peripherals.h file. The definition name is &lt;Alias_Name&gt;_HW.</para></listitem></itemizedlist>
</para><para>The generated code will be available under the GeneratedSource folder.</para><para>Refer to <ref kindref="member" refid="index_1section_csdidac_quick_start">Quick Start Guide</ref> section for the application layer code required to set up the CSDIDAC and to get the desired current on the assigned pin.</para>

<para><bold>Implement the initialization code manually</bold></para>
<para>The steps required to implement the initialization code manually:<orderedlist>
<listitem><para>Launch the ModusToolbox Middleware Selector and enable the CSD IDAC middleware. This step is required only if the ModusToolbox IDE is used. Otherwise, ensure the CSDIDAC Middleware is included in your project.</para></listitem><listitem><para>Define the CSD HW block base address. See the code example below: <programlisting><codeline><highlight class="preprocessor">#define<sp />CSDIDAC_HW<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CSD0)</highlight></codeline>
</programlisting></para></listitem><listitem><para>Declare the CSD HW driver context structure and initialize the lockKey field with the CY_CSD_NONE_KEY value. See the code example below: <programlisting><codeline><highlight class="normal">cy_stc_csd_context_t<sp />csdDriverContext<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.lockKey<sp />=<sp />CY_CSD_NONE_KEY,<sp /></highlight><highlight class="comment">/*<sp />Initialization<sp />of<sp />the<sp />lockKey<sp />with<sp />the<sp />CY_CSD_NONE_KEY</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />is<sp />required<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting></para></listitem><listitem><para>Declare the CSDIDAC configuration structure and initialize it according to the desired parameters. See the code example below: <programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />the<sp />IDAC<sp />A<sp />channel<sp />to<sp />P0[4]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__csdidac__pin__t">cy_stc_csdidac_pin_t</ref><sp />csdIdacAPin<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__csdidac__pin__t_1a8b26d10faee8d2524aa368f4f1e9c6ff">ioPcPtr</ref><sp />=<sp />GPIO_PRT0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.pin<sp />=<sp />4u,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Assign<sp />the<sp />IDAC<sp />B<sp />channel<sp />to<sp />P0[5]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__csdidac__pin__t">cy_stc_csdidac_pin_t</ref><sp />csdIdacBPin<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__csdidac__pin__t_1a8b26d10faee8d2524aa368f4f1e9c6ff">ioPcPtr</ref><sp />=<sp />GPIO_PRT0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.pin<sp />=<sp />5u,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__csdidac__config__t">cy_stc_csdidac_config_t</ref><sp />CSDIDAC_csdidac_config<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__csdidac__config__t_1aa729f9b1a91feb0cc616285bdcf3a0ed">base</ref><sp />=<sp />CSDIDAC_HW,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />CSD0<sp />HW<sp />block<sp />is<sp />selected<sp />for<sp />CSDIDAC<sp />operation.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.csdCxtPtr<sp />=<sp />&amp;csdDriverContext,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />CSD<sp />driver<sp />context<sp />structure.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.configA<sp />=<sp /><ref kindref="member" refid="group__group__csdidac__enums_1gga5042fa555ce33ff612236511a5397f13aeaf70cb0679eb8cd53085533135ac313">CY_CSDIDAC_GPIO</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Routes<sp />the<sp />IDAC<sp />A<sp />output<sp />to<sp />the<sp />pin.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.configB<sp />=<sp /><ref kindref="member" refid="group__group__csdidac__enums_1gga5042fa555ce33ff612236511a5397f13aeaf70cb0679eb8cd53085533135ac313">CY_CSDIDAC_GPIO</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Routes<sp />the<sp />IDAC<sp />B<sp />output<sp />to<sp />the<sp />pin.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.ptrPinA<sp />=<sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__csdidac__pin__t">cy_stc_csdidac_pin_t</ref><sp />*)<sp />&amp;csdIdacAPin,<sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />structure<sp />with<sp />configured<sp />IDAC<sp />A<sp />Port/Pin.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.ptrPinB<sp />=<sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__csdidac__pin__t">cy_stc_csdidac_pin_t</ref><sp />*)<sp />&amp;csdIdacBPin,<sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />structure<sp />with<sp />configured<sp />IDAC<sp />B<sp />Port/Pin.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.cpuClk<sp />=<sp />48000000u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Provides<sp />the<sp />absolute<sp />CPU<sp />clock<sp />frequency<sp />in<sp />the<sp />current<sp />design<sp />(configured<sp />to<sp />48MHz).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXCSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.csdInitTime<sp />=<sp />25u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configures<sp />the<sp />CSD0<sp />wake-up<sp />initialization<sp />time<sp />to<sp />25<sp />us<sp />(as<sp />default)<sp />for<sp />the<sp />PSoC<sp />6<sp />device.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.csdInitTime<sp />=<sp />10u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configures<sp />the<sp />CSD0<sp />wake-up<sp />initialization<sp />time<sp />to<sp />10<sp />us<sp />(as<sp />default)<sp />for<sp />the<sp />PSoC<sp />4<sp />device.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCSDV2<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting></para></listitem><listitem><para>Assign the Peripheral Clock Divider to the CSD HW block and configure the divider value. See the code example below and refer to the main() routine code snippet in <ref kindref="member" refid="index_1section_csdidac_quick_start">Quick Start Guide</ref> <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />The<sp />code<sp />below<sp />performs<sp />the<sp />following<sp />operations:</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />1.<sp />Disable<sp />the<sp />Peripheral<sp />Clock<sp />Divider<sp />with<sp />index<sp />#0<sp />before<sp />it</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp />is<sp />assigned<sp />to<sp />the<sp />CSD<sp />HW<sp />block.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />2.<sp />Assign<sp />the<sp />Peripheral<sp />Clock<sp />Divider<sp />with<sp />index<sp />#0<sp />to<sp />the<sp />CSD<sp />HW<sp />block.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />3.<sp />Configure<sp />the<sp />assigned<sp />divider<sp />with<sp />divider<sp />value<sp />0<sp />(to<sp />divide<sp />by<sp />1).</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />4.<sp />Enable<sp />the<sp />assigned<sp />divider.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />PCLK_CSD_CLOCK<sp />-<sp />Connects<sp />the<sp />divider<sp />to<sp />the<sp />CSD<sp />HW<sp />block</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />CY_SYSCLK_DIV_8_BIT<sp />-<sp />Uses<sp />the<sp />8-bit<sp />divider.<sp />This<sp />divider<sp />is<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />limit<sp />the<sp />CSD<sp />clock<sp />frequency<sp />to<sp />50<sp />MHz.<sp />The<sp />Peri<sp />Clock<sp />frequency</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />is<sp />48<sp />MHz<sp />(refer<sp />to<sp />the<sp />Configuration<sp />Considerations<sp />section),<sp />so<sp />the<sp />divider</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />value<sp />is<sp />0<sp />(to<sp />divide<sp />by<sp />1).<sp />No<sp />need<sp />for<sp />a<sp />wider<sp />divider<sp />type.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />0<sp />=<sp />select<sp />divider<sp />with<sp />index<sp />#0.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXCSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PeriphDisableDivider(CY_SYSCLK_DIV_8_BIT,<sp />0u);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PeriphAssignDivider(PCLK_CSD_CLOCK,<sp />CY_SYSCLK_DIV_8_BIT,<sp />0u);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PeriphSetDivider(CY_SYSCLK_DIV_8_BIT,<sp />0u,<sp />0u);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PeriphEnableDivider(CY_SYSCLK_DIV_8_BIT,<sp />0u);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#elif<sp />defined(CY_IP_M0S8CSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PeriphDisableDivider(CY_SYSCLK_DIV_16_BIT,<sp />0u);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PeriphAssignDivider(PCLK_CSD_CLOCK,<sp />CY_SYSCLK_DIV_16_BIT,<sp />0u);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PeriphSetDivider(CY_SYSCLK_DIV_16_BIT,<sp />0u,<sp />0u);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PeriphEnableDivider(CY_SYSCLK_DIV_16_BIT,<sp />0u);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#error<sp />Not<sp />supported<sp />device</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCSDV2<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>Set the configuration of the HSIOM_AMUX_SPLIT_CTL switches to route signal from CSD HW block to the pins configured as the CSDIDAC output channels.</para><para>The AMUX bus has segments that are separated with the HSIOM_AMUX_SPLIT_CTL switches. The code below closes the AMUX_SPLIT_CTL switches, which route the IDAC output signal from the CSD block to the pin. In this example, IDAC output channels are assigned to the P0[4] and P[5] pins. The AMUX_SPLIT_CTL[5] and AMUX_SPLIT_CTL[6] switches must be closed in the PSoC6 device. The P0[4] and P[5] pins in the PSoC4 device belong to the AMUX bus segment, which is connected to the CSD block directly. In this case, the AMUX_SPLIT_CTL switches are not closed. Refer to the <ulink url="http://www.cypress.com/trm218176">Technical Reference Manual (TRM)</ulink> for more information regarding the analog interconnection. See the code example below and refer to the main() routine code snippet in <ref kindref="member" refid="index_1section_csdidac_quick_start">Quick Start Guide</ref> <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXCSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if(1u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[5]<sp />=<sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_AA_SL_Msk<sp />|<sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-A<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_AA_SR_Msk<sp />|<sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-A<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|<sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[6]<sp />=<sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_AA_SL_Msk<sp />|<sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-A<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#6.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_AA_SR_Msk<sp />|<sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-A<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#6.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|<sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#6.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#6.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#elif(2u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[5]<sp />=<sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_AA_SL_Msk<sp />|<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-A<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_AA_SR_Msk<sp />|<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-A<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[6]<sp />=<sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_AA_SL_Msk<sp />|<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-A<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#6.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_AA_SR_Msk<sp />|<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-A<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#6.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#6.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#6.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#error<sp />Not<sp />supported<sp />device</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />(1u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCSDV2<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If you use a KIT, check on the schematics, if pins P0[4] and P0[5] are free. If not, use some other pins and update the AMUX_SPLIT_CTL registers. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Some CSDIDAC configurations are restricted. The CSD personality has a mechanism to prevent writing an invalid configuration. If CSDIDAC is manually created, avoid the following combinations:&lt;ul&gt;&lt;li&gt;&lt;p&gt;both IDAC channels are disabled&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;one IDAC channel is disabled and another channel is joined to it&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;the IDAC A channel and IDAC B channel are joined to each other&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Refer to </verbatim><ref kindref="member" refid="index_1section_csdidac_quick_start">Quick Start Guide</ref> section for the application layer code required to set up the CSDIDAC and to get the desired current on the assigned pin.</para></listitem></orderedlist>
</para>


<para><heading level="1">Use Cases</heading></para>
<para>This section provides descriptions and links to additional documentation for some specific CSDIDAC use cases.</para>
<para><bold>Low power design</bold></para>
<para>The CSD HW block and CSDIDAC middleware can operate in CPU active and CPU sleep power modes. It is also possible to switch between low power and ultra low power system modes. In System Deep Sleep and Hibernate power modes, the CSD HW block is powered off and CSDIDAC operations are not performed. Before entering CPU / System Deep Sleep, disable CSDIDAC output current generation. If output currents are not disabled, a CPU Deep Sleep transition will fail. When the device wakes up from CPU / System Deep Sleep, the CSD HW block resumes operation without the need for re-initialization and the CSDIDAC operations can be continued with configuration that was set before a CPU / System Deep Sleep transition. When the device wakes up from Hibernate power mode, the CSD HW block does not retain the configuration and CSDIDAC requires re-initialization.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;ol&gt;&lt;li&gt;&lt;p&gt;Analog start up time for the CSD HW block is 25 us for PSoC6 devices and 10 us for PSoC4 devices. Initiate any kind of operation only after 25 us for PSoC6 devices and 10 us for PSoC4 devices from System Deep Sleep / Hibernate exit.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Entering CPU Deep Sleep mode does not mean the device enters System Deep Sleep. For more detail about switching to System Deep Sleep, refer to the device TRM.&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Refer to the </verbatim><ref kindref="member" refid="group__group__csdidac__functions_1ga462081bf4af5529dd249dc2d6f7cdf09">Cy_CSDIDAC_DeepSleepCallback()</ref> function description and to the SysPm (System Power Management) driver documentation for the low power design considerations.</para><para><bold>Sleep mode</bold><linebreak />
 The CSD HW block can operate in CPU sleep mode. The user can start CSDIDAC and move CPU into sleep mode to reduce power consumption. After wake-up CPU from sleep, the user can perform other operations, e.g. disable IDACs. Then, the user configures the CSDIDAC middleware as described in <ref kindref="member" refid="index_1section_csdidac_configuration">Configuration Considerations</ref>, and updates the main() routine with the following code: <programlisting><codeline><highlight class="normal"><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />There<sp />is<sp />a<sp />need<sp />to<sp />generate<sp />two<sp />output<sp />currents<sp />while<sp />CPU<sp />is<sp />in<sp />Sleep<sp />mode.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Starts<sp />CSDIDAC<sp />generation<sp />of<sp />two<sp />output<sp />currents.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdidac__enums_1gga24fb43a86985211116353da8b9e2a24ea329aa4f72fb60a00751eec512e0c339e">CY_CSDIDAC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdidac__functions_1gab98734d77671b95d22aed6976c843afe">Cy_CSDIDAC_OutputEnable</ref>(<ref kindref="member" refid="group__group__csdidac__enums_1gga50d76718e6bca3ac87f455c074cbbc10afd995410b7ce2229624433f60708969c">CY_CSDIDAC_A</ref>,<sp />50000,<sp />&amp;csdidac_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdidac__enums_1gga24fb43a86985211116353da8b9e2a24ea329aa4f72fb60a00751eec512e0c339e">CY_CSDIDAC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdidac__functions_1gab98734d77671b95d22aed6976c843afe">Cy_CSDIDAC_OutputEnable</ref>(<ref kindref="member" refid="group__group__csdidac__enums_1gga50d76718e6bca3ac87f455c074cbbc10a708c231fc2cdb553d777ea0108b44465">CY_CSDIDAC_B</ref>,<sp />-500,<sp />&amp;csdidac_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Goes<sp />to<sp />CPU<sp />Sleep<sp />mode<sp />and<sp />waits<sp />for<sp />an<sp />interrupt<sp />(or<sp />another<sp />wake-up<sp />event).</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />It<sp />is<sp />the<sp />user's<sp />responsibility<sp />to<sp />provide<sp />an<sp />interrupt<sp />source<sp />for<sp />a<sp />reliable<sp />CPU<sp />wake-up.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />defined(CY_IP_MXCSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SYSPM_SUCCESS<sp />!=<sp />Cy_SysPm_CpuEnterSleep(CY_SYSPM_WAIT_FOR_INTERRUPT))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#elif<sp />defined(CY_IP_M0S8CSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SYSPM_SUCCESS<sp />!=<sp />Cy_SysPm_CpuEnterSleep())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#error<sp />Not<sp />supported<sp />device</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCSDV2<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Insert<sp />here<sp />code<sp />to<sp />perform<sp />after<sp />Sleep<sp />mode<sp />operations,<sp />e.g.<sp />to<sp />disable<sp />IDACs.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> <bold>Deep Sleep mode</bold><linebreak />
 To use the CSDIDAC middleware in CPU / System Deep Sleep mode, the user configures a wake-up source (e.g. a pin, WDT, LPC or another entities, that are active in CPU / System Deep Sleep mode), configures the CSDIDAC middleware as described in <ref kindref="member" refid="index_1section_csdidac_configuration">Configuration Considerations</ref>, configures CSDIDAC and other drivers' and middleware's (if present) Deep Sleep Callback structures, registers callbacks, and updates the main() routine with the following code: <programlisting><codeline><highlight class="comment">/*<sp />CSDIDAC<sp />DeepSleep<sp />Callback<sp />parameters<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">cy_stc_syspm_callback_params_t<sp />CSDIDAC_deepSleepParamStr<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CSDIDAC_HW,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />CSD<sp />HW<sp />block<sp />base<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />&amp;csdidac_context,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />CSDIDAC<sp />context<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp /><sp />CSDIDAC<sp />DeepSleep<sp />Callback<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">cy_stc_syspm_callback_t<sp />CSDIDAC_deepSleepCallbackStr<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />&amp;<ref kindref="member" refid="group__group__csdidac__functions_1ga462081bf4af5529dd249dc2d6f7cdf09">Cy_CSDIDAC_DeepSleepCallback</ref>,<sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />CSDIDAC<sp />Callback<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_SYSPM_DEEPSLEEP,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />Callback<sp />type<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />0u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />skip<sp />modes<sp />mask<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />&amp;CSDIDAC_deepSleepParamStr,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />Callback<sp />parameters<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NULL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reserved<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NULL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reserved<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />10u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />callback<sp />priority,<sp />can<sp />be<sp />from<sp />1<sp />(the<sp />highest)<sp />to<sp />255<sp />(the<sp />lowest)*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal"><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp />*<sp />Scenario:<sp />There<sp />is<sp />a<sp />need<sp />to<sp />generate<sp />two<sp />output<sp />currents<sp />and<sp />use<sp />them<sp />for<sp />some<sp />operations,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp />*<sp />and<sp />then<sp />go<sp />to<sp />Deep<sp />Sleep<sp />with<sp />wake-up<sp />on<sp />some<sp />event.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Registers<sp />CSDIDAC<sp />DeepSleep<sp />Callback.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(</highlight><highlight class="keyword">true</highlight><highlight class="normal"><sp />!=<sp />Cy_SysPm_RegisterCallback(&amp;CSDIDAC_deepSleepCallbackStr))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Starts<sp />CSDIDAC<sp />generation<sp />of<sp />two<sp />output<sp />currents.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdidac__enums_1gga24fb43a86985211116353da8b9e2a24ea329aa4f72fb60a00751eec512e0c339e">CY_CSDIDAC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdidac__functions_1gab98734d77671b95d22aed6976c843afe">Cy_CSDIDAC_OutputEnable</ref>(<ref kindref="member" refid="group__group__csdidac__enums_1gga50d76718e6bca3ac87f455c074cbbc10afd995410b7ce2229624433f60708969c">CY_CSDIDAC_A</ref>,<sp />50000,<sp />&amp;csdidac_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdidac__enums_1gga24fb43a86985211116353da8b9e2a24ea329aa4f72fb60a00751eec512e0c339e">CY_CSDIDAC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdidac__functions_1gab98734d77671b95d22aed6976c843afe">Cy_CSDIDAC_OutputEnable</ref>(<ref kindref="member" refid="group__group__csdidac__enums_1gga50d76718e6bca3ac87f455c074cbbc10a708c231fc2cdb553d777ea0108b44465">CY_CSDIDAC_B</ref>,<sp />-500,<sp />&amp;csdidac_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Insert<sp />here<sp />code<sp />to<sp />use<sp />generated<sp />currents.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disables<sp />CSDIDAC<sp />generation<sp />to<sp />allow<sp />a<sp />Deep<sp />Sleep<sp />transition.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdidac__enums_1gga24fb43a86985211116353da8b9e2a24ea329aa4f72fb60a00751eec512e0c339e">CY_CSDIDAC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdidac__functions_1ga7345b3e6b0090d3e53e68fd3f66ed09c">Cy_CSDIDAC_OutputDisable</ref>(<ref kindref="member" refid="group__group__csdidac__enums_1gga50d76718e6bca3ac87f455c074cbbc10ab653b4daaf8d72d5efef83eb8e782367">CY_CSDIDAC_AB</ref>,<sp />&amp;csdidac_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Then<sp />CPU<sp />goes<sp />to<sp />Deep<sp />Sleep<sp />and<sp />waits<sp />for<sp />an<sp />interrupt<sp />(or<sp />another<sp />wake-up<sp />event).</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />It<sp />is<sp />the<sp />user's<sp />responsibility<sp />to<sp />provide<sp />an<sp />interrupt<sp />source<sp />for<sp />a<sp />reliable<sp />CPU<sp />wake-up.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />defined(CY_IP_MXCSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SYSPM_SUCCESS<sp />!=<sp />Cy_SysPm_CpuEnterDeepSleep(CY_SYSPM_WAIT_FOR_INTERRUPT))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#elif<sp />defined(CY_IP_M0S8CSDV2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SYSPM_SUCCESS<sp />!=<sp />Cy_SysPm_CpuEnterDeepSleep())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#error<sp />Not<sp />supported<sp />device</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCSDV2<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wakes<sp />up<sp />CSDIDAC<sp />after<sp />a<sp />successful<sp />exit<sp />from<sp />Deep<sp />Sleep.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdidac__enums_1gga24fb43a86985211116353da8b9e2a24ea329aa4f72fb60a00751eec512e0c339e">CY_CSDIDAC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdidac__functions_1gaf456eb58309f99e2921ade09f47bdffe">Cy_CSDIDAC_Wakeup</ref>(&amp;csdidac_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />After<sp />Deep<sp />Sleep,<sp />CPU<sp />and<sp />CSD<sp />HW<sp />block<sp />wake-up,<sp />CSDIDAC<sp />can<sp />generate</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />two<sp />output<sp />currents,<sp />as<sp />it<sp />was<sp />configured<sp />before<sp />transitions.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para>

<para><bold>Time-multiplexing operation</bold></para>
<para>Refer to the <ulink url="https://cypresssemiconductorco.github.io/capsense/capsense_api_reference_manual/html/index.html">CapSense Middleware API Reference Guide</ulink> for implementation of the time-multiplexing operation by using common CSD HW block.</para>


<para><heading level="1">Supported Software and Tools</heading></para>
<para>This version of the CSDIDAC Middleware was validated for compatibility with the following Software and Tools:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Software and Tools &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Version  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;ModusToolbox Software Environment &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox CSD Personality for PSoC4 devices in Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox CSD Personality for PSoC6 devices in Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;PSoC4 Peripheral Driver Library (PDL) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.0.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;PSoC6 Peripheral Driver Library (PDL) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.5.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GCC Compiler &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;IAR Compiler &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;8.32  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Arm Compiler 6 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;6.11  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBED OS (only for PSoC6) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;5.15.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;FreeRTOS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;10.0.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Update to Newer Versions</heading></para>
<para>Consult <ref kindref="member" refid="index_1group_csdidac_changelog">Changelog</ref> to learn about the design impact of the newer version. Set up your environment in accordance with <ref kindref="member" refid="index_1section_csdidac_toolchain">Supported Software and Tools</ref>. You might need to re-generate the configuration structures for either the device initialization code or the middleware initialization code.</para><para>Ensure:<itemizedlist>
<listitem><para>The specified version of the ModusToolbox Device Configurator and the CSD personality are used to re-generate the device configuration.</para></listitem><listitem><para>The toolchains are set up properly for your environment per the settings outlined in the Supported Software and Tools.</para></listitem><listitem><para>The project is re-built once the the toolchains are configured and the configuration is completed.</para></listitem></itemizedlist>
</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The Cy_CSDIDAC library has the following specific deviations:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Do not perform a conversion between the pointer to an object and an integer type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Such a conversion is performed with CSDIDAC context in the DeepSleepCallback() function. This case is verified on correct operation.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.2 &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;Constant: De-reference of the NULL pointer. &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;These violations are reported as a result of using offset macros of the CSD Driver with corresponding documented violation 20.6. Refer to the CSD Driver API Reference Guide.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;20.3  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added the support of PSoC 4 CapSense Forth Generation devices &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Devices support  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Minor documentation update &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation cleanup  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="5"&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The joining two IDAC channels option is added to increase the maximum CSDIDAC output current  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Feature enchancement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="structcy__stc__csdidac__config__t.html#"&gt;cy_stc_csdidac_config_t&lt;/a&gt; structure is changed: the periClk field replaced with cpuClk, busOnlyA and busOnlyB fields replaced with configA and configB fields respectively, the field order is changed. The &lt;a href="group__group__csdidac__enums.html#group__group__csdidac__enums_1ga5042fa555ce33ff612236511a5397f13"&gt;cy_en_csdidac_channel_config_t&lt;/a&gt; enumeration type is added. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="group__group__csdidac__enums.html#group__group__csdidac__enums_1gga24fb43a86985211116353da8b9e2a24ea7f263aa3f12c05133a56b287eac7c0d0"&gt;CY_CSDIDAC_HW_FAILURE&lt;/a&gt; and the &lt;a href="group__group__csdidac__enums.html#group__group__csdidac__enums_1gga24fb43a86985211116353da8b9e2a24ead394bb35be8cc2dd89290b9226ac7044"&gt;CY_CSDIDAC_BAD_CONFIGURATION&lt;/a&gt; return status cases are added to the &lt;a href="group__group__csdidac__enums.html#group__group__csdidac__enums_1ga24fb43a86985211116353da8b9e2a24e"&gt;cy_en_csdidac_status_t&lt;/a&gt; enumeration type &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="group__group__csdidac__enums.html#group__group__csdidac__enums_1gga50d76718e6bca3ac87f455c074cbbc10ab653b4daaf8d72d5efef83eb8e782367"&gt;CY_CSDIDAC_AB&lt;/a&gt; choosing case for both IDACs is added to the &lt;a href="group__group__csdidac__enums.html#group__group__csdidac__enums_1ga50d76718e6bca3ac87f455c074cbbc10"&gt;cy_en_csdidac_choice_t&lt;/a&gt; enumeration type &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Feature enchancement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The CSDIDAC MW sources are enclosed with the conditional compilation to ensure a successful compilation for non-CapSense-capable devices &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Compilation for non-CapSense-capable devices  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">More Information</heading></para>
<para>Important information about the CapSense-technology overview, appropriate device for the design, CapSense system and sensor design guidelines, different interfaces and tuning guidelines necessary for a successful design of a CapSense system is available in the Getting Started with CapSense document and the product-specific CapSense design guide. It is highly recommended to start with these documents. They can be found at www.cypress.com.</para><para>For more information, refer to the following documents:</para><para><itemizedlist>
<listitem><para>CapSense and CSDIDAC Overview:<itemizedlist>
<listitem><para><ulink url="https://github.com/cypresssemiconductorco/mbed-os-example-csdidac">CSDIDAC Middleware Code Example for MBED OS</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/capsense/capsense_api_reference_manual/html/index.html">CapSense Middleware API Reference Guide</ulink></para></listitem></itemizedlist>
</para></listitem><listitem><para>ModusToolbox Overview:<itemizedlist>
<listitem><para><ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox Software Environment, Quick Start Guide, Documentation, and Videos</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool Guide</ulink></para></listitem></itemizedlist>
</para></listitem><listitem><para>Kits:<itemizedlist>
<listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/cy8ckit-145-40xx-psoc-4000s-capsense-prototyping-kit">CY8CKIT-145-40XX PSoC 4000S CapSense Prototyping Kit</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/cy8ckit-149-psoc-4100s-plus-prototyping-kit">CY8CKIT-149 PSoC 4100S Plus Prototyping Kit</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/cy8ckit-041-psoc-4-s-series-pioneer-kit">CY8CKIT-041-40XX PSoC 4 S-Series Pioneer Kit</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/cy8ckit-041-41xx-psoc-4100s-capsense-pioneer-kit">CY8CKIT-041-41XX PSoC 4100S CapSense Pioneer Kit</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/psoc-6-ble-pioneer-kit-cy8ckit-062-ble">CY8CKIT-062-BLE PSoC 6 BLE Pioneer Kit</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/psoc-6-wifi-bt-pioneer-kit-cy8ckit-062-wifi-bt">CY8CKIT-062-WiFi-BT PSoC 6 WiFi-BT Pioneer Kit</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/psoc-6-wi-fi-bt-prototyping-kit-cy8cproto-062-4343w">CY8CPROTO-062-4343W PSoC 6 Wi-Fi BT Prototyping Kit</ulink></para></listitem></itemizedlist>
</para></listitem><listitem><para>General Information:<itemizedlist>
<listitem><para><ulink url="https://github.com/cypresssemiconductorco.github.io/psoc4pdl/pdl_api_reference_manual/html/index.html">PSoC 4 PDL API Reference</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/psoc6pdl">PSoC 6 PDL API Reference</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/technical-reference-manuals/psoc-6-mcu-psoc-63-ble-architecture-technical-reference">PSoC 6 Technical Reference Manual</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/ds218787">PSoC 63 with BLE Datasheet Programmable System-on-Chip datasheet</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/technical-reference-manuals/psoc-4000s-family-psoc-4-architecture-technical-reference">PSoC 4000S Family: PSoC 4 Architecture Technical Reference Manual (TRM)</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/technical-reference-manuals/psoc-4100s-and-psoc-4100s-plus-psoc-4-architecture">PSoC 4100S and PSoC 4100S Plus: PSoC 4 Architecture Technical Reference Manual (TRM)</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco"> Cypress Semiconductor GitHub</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com">Cypress Semiconductor</ulink></para></listitem></itemizedlist>
</para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The links to another software component's documentation (middleware and PDL) point to GitHub to the latest available version of the software. To get documentation of the specified version, download from GitHub and unzip the component archive. The documentation is available in the &lt;i&gt;docs&lt;/i&gt; folder. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>